#!/bin/bash

#if [[ $# -eq 0 ]]; then
#	usage "$0"
#else

EZFLA_UP_ORG=ezfla_up.bin
EZFLA_UP_NEW=ezfla_up2.bin
EZFLA_UP_NEW2=ezfla_up3.bin
HEXALTER="hexalter"

SHIFT_FILEMANAGER_BACKGROUND_DOWN="0x5f30=0x18"
SHIFT_FILEMANAGER_HEADER_DOWN="0x5eac=0x18"
SHIFT_ICONS_LEFT="0x112a=0x04"
FIX_BACKGROUND_CHECKS="0x390a=0xf0 0x38ee=0xa0"
FIX_DIALOG_SHADOW="0x44e4=0x37 0x4504=0x36"
FIX_TIME_SHADOW="0x50d6=0x44 0x50ea=0x43"
FIX_LOAD_SHADOW="0x525a=0x44 0x526e=0x43"
ICONS_TRANSPARENCY_UPPER_LEFT_CORNER="0x3950=0x00,0x23,0xfb,0x5a"

SHIFTS="$SHIFT_FILEMANAGER_BACKGROUND_DOWN $SHIFT_FILEMANAGER_HEADER_DOWN $SHIFT_ICONS_LEFT"
FIXES="$SHIFTS $FIX_BACKGROUND_CHECKS $FIX_VERSION_COLOR $FIX_DIALOG_SHADOW $FIX_TIME_SHADOW $FIX_LOAD_SHADOW $ICONS_TRANSPARENCY_UPPER_LEFT_CORNER"

source colors.txt

#bgr() {
# c=${1:5}${1:2:2}
# printf "#%02x%02x%02x\n" $(((c&31)<<3)) $((((c>>5)&31)<<3)) $((((c>>10)&31)<<3))
#}

sanity() {
	if [[ "${1:0:2}" != "0x" ]]; then
		echo Error with $2
		exit 1
	fi
}

RGB24toBGR15() {
	r=0x"${1:1:2}"
	g=0x"${1:3:2}"
	b=0x"${1:5:2}"
	printf "%04x\n" $((($r>>3) | ((g>>3)<<5) | ((b>>3)<<10)))
}

color() {
	if [[ "${1:0:1}" == \# ]]; then
		c=$(RGB24toBGR15 $1)
	elif [[ "${1:0:2}" == "0x" && ${#1} -eq 6 ]]; then
		c=${1:2:4}
	elif [[ ${#1} -eq 4 ]]; then
		c=$1
	else
		echo -1
	fi
	echo 0x"${c:2:2}",0x"${c:0:2}"
}

bin2hexalter() {
	echo ${2}="$(hexdump -v -s ${2} -n $((${3}-${2})) -e "1/1 \"0x%02x,\"" "${1}" | sed 's/,$//')"
}

	c=$(color "$COLOR_FILEMANAGER_SELECTION_BAR")
	sanity "$c" COLOR_FILEMANAGER_SELECTION_BAR
	#FILEMANAGER_SELECTION_BAR="0x62c4=$c 0x6754=$c 0x6b74=$c"
	FILEMANAGER_SELECTION_BAR="0x5e68=$c 0x62c4=$c 0x6754=$c 0x6b74=$c"


	c=$(color "$COLOR_SETTINGS_SELECTION_BAR")
	sanity "$c" COLOR_SETTINGS_SELECTION_BAR
	SETTINGS_SELECTION_BAR="0x9810="$c

	c=$(color "$COLOR_DIALOG_BACKGROUND")
	sanity "$c" COLOR_DIALOG_BACKGROUND
	#DIALOG_BACKGROUND="0x1004=$c 0x5196=0xc0,0x46 0x51e0=$c"
	DIALOG_BACKGROUND="0x1004=$c 0xbaa=0xc0,0x46 0xbe8=$c 0x7b5c=$c 0x5196=0xc0,0x46 0x51e0=$c"

	COLORS="$FILEMANAGER_SELECTION_BAR $SETTINGS_SELECTION_BAR $DIALOG_BACKGROUND"

	#new_font_stub.bin
	NEW_FONT_STUB_BIN="0x3208=0x00,0x4c,0x20,0x47,0x81,0x2a,0x1d,0x08"
	CHANGES="$NEW_FONT_STUB_BIN $FIXES $COLORS"
	NOP_OUT_FOR_TESTING="0x1758=0xc0,0x46"

	cat $EZFLA_UP_ORG new_font.bin > $EZFLA_UP_NEW
	$HEXALTER $EZFLA_UP_NEW $CHANGES
	cp $EZFLA_UP_NEW $EZFLA_UP_NEW2
	$HEXALTER $EZFLA_UP_NEW $NOP_OUT_FOR_TESTING

#	if [[ "${1: -3}" == ".sh" ]]; then
#		NOP_OUT_FOR_TESTING="0x1758=0xc0,0x46"
#		echo "#!/bin/sh" > "${1}"
#		echo cp $EZFLA_UP_ORG $EZFLA_UP_NEW >> "${1}"
#		echo $HEXALTER $EZFLA_UP_NEW $CHANGES $NOP_OUT_FOR_TESTING >> "${1}"
#		chmod u+x "${1}"
#	elif [[ "${1: -4}" == ".ips" ]]; then
#		#NOP_OUT_FOR_TESTING="0x1758=0xc0,0x46"
#		$HEXALTER -i "${1}" $CHANGES #$NOP_OUT_FOR_TESTING
#	else
#		usage "$0" 
#	fi
#fi
